
# Selected algorithms implementation in Python

## Table of Content

* [Algorithms on integers](#algorithms-on-integers)
* [Sorting algorithms](#sorting-algorithms)
* [Numerical algorithms](#numerical-algorithms)
* [String algorithms](#string-algorithms)
* [Ciphers](#ciphers)
* [Geometric properties algorithms](#geometric-properties-algorithms)


## Algorithms on integers
#### Euclidean algorithm
#### Fibonacci algorithm
#### Is number prime
#### Is number perfect
#### Number decomposition
#### Number system conversion

[Detailed description of integer algorithms here](algorithms/integers/README.md)

## Sorting algorithms
#### Bubble sort
#### Quick sort
#### Binary sort
#### Insertion sort
#### Selection sort

[Detailed description of sorting algorithms here](algorithms/sorting/README.md)
    
## Numerical algorithms
#### Bisection root finding
#### Horner algorithm
#### Fast exponentiation
#### Trapezoid integration
#### Rectangular integration
#### Square root

[Detailed description of numerical algorithms here](algorithms/numerical/README.md)

## String algorithms
#### Is string palindrome
#### Is string anagram
#### Lexicographical sorting
#### Pattern finding

[Detailed description of string algorithms here](algorithms/strings/README.md)

## Ciphers
#### Caesar cipher
#### Morse code cipher
#### Swap cipher

[Detailed description of cipher algorithms here](algorithms/ciphers/README.md)

## Geometric properties algorithms
#### Triangle properties
#### Point position
#### Is point on segment

[Detailed description of geometric properties algorithms here](algorithms/geometric_properties/README.md)
